package convert

import (
	"encoding/json"
	"io"
	"strings"

	log "github.com/sirupsen/logrus"

	"gitlab.com/gitlab-org/security-products/analyzers/common/v2/issue"
)

const (
	scannerID   = "tslint"
	scannerName = "TSLint"
)

// Convert reads a native report from the tool (TSLint) and transforms it
// into issues, as defined in the common module
func Convert(reader io.Reader, prependPath string) (*issue.Report, error) {
	var vulnerabilities []TSLintVulnerability

	err := json.NewDecoder(reader).Decode(&vulnerabilities)
	if err != nil {
		return nil, err
	}

	var scanner = issue.Scanner{
		ID:   scannerID,
		Name: scannerName,
	}

	// Create issues from the report
	issues := make([]issue.Issue, 0)
	for _, vulnerability := range vulnerabilities {
		description, ok := descriptions[vulnerability.RuleName]
		if !ok {
			if !strings.HasPrefix(vulnerability.RuleName, "tsr-") {
				// This vulnerability was generated by a rule outside the security plugin, Skip it.
				continue
			}

			// This is an unknown rule. Warn user and use default values.
			log.Warnf(
				"No description for TSLint rule %s. Please open an issue on https://gitlab.com/gitlab-org/gitlab-ee/issues\n",
				vulnerability.RuleName)

			description = vulnerability.Failure
		}

		newIssue := issue.Issue{
			Category:    issue.CategorySast,
			Scanner:     scanner,
			Name:        vulnerability.Failure,
			Message:     vulnerability.Failure,
			Description: description,
			CompareKey:  vulnerability.compareKey(),
			Severity:    issue.SeverityLevelUnknown,
			Confidence:  issue.ConfidenceLevelUnknown,
			Location:    vulnerability.location(prependPath),
			Identifiers: vulnerability.identifiers(),
		}

		issues = append(issues, newIssue)
	}

	report := issue.NewReport()
	report.Vulnerabilities = issues
	return &report, nil
}

// Descriptions for each rule from the TSLint security plugin. Adapted from
// https://github.com/webschik/tslint-config-security#rules
var descriptions = map[string]string{
	"tsr-detect-unsafe-regexp":                     "Locates potentially unsafe regular expressions, which may take a very long time to run, blocking the event loop.",
	"tsr-detect-non-literal-buffer":                "Detects variable in `new Buffer` argument.",
	"tsr-detect-buffer-noassert":                   "Detects calls to `Buffer` with `noAssert` flag set.",
	"tsr-detect-child-process":                     "Detects instances of `child_process` & non-literal `exec()`",
	"tsr-disable-mustache-escape":                  "Detects `object.escapeMarkup = false`, which can be used with some template engines to disable escaping of HTML entities. This can lead to Cross-Site Scripting (XSS) vulnerabilities.",
	"tsr-detect-eval-with-expression":              "Detects `eval(variable)` which can allow an attacker to run arbitary code inside your process.",
	"tsr-detect-no-csrf-before-method-override":    "Detects Express csrf middleware setup before method-override middleware. This can allow GET requests (which are not checked by csrf) to turn into POST requests later.",
	"tsr-detect-non-literal-fs-filename":           "Detects variable in filename argument of fs calls, which might allow an attacker to access anything on your system.",
	"tsr-detect-non-literal-regexp":                "Detects `RegExp(variable)`, which might allow an attacker to DOS your server with a long-running regular expression.",
	"tsr-detect-non-literal-require":               "Detects `require(variable)`, which might allow an attacker to load and run arbitrary code, or access arbitrary files on disk.",
	"tsr-detect-possible-timing-attacks":           "Detects insecure comparisons (==, !=, !== and ===), which check input sequentially.",
	"tsr-detect-pseudo-random-bytes":               "Detects if pseudoRandomBytes() is in use, which might not give you the randomness you need and expect.",
	"tsr-detect-html-injection":                    "Detects HTML injections.",
	"tsr-detect-sql-literal-injection":             "Detects possible SQL injections in string literals:",
	"tsr-detect-unsafe-cross-origin-communication": "Detects when all windows & frames on your page (including ones that were injected by 3rd-party scripts) may receive your data.",
	"tsr-detect-unsafe-properties-access":          "Detects a potential unsafe access to the object properties",
}
